%global goipath gvisor.dev/gvisor
%global commit 5fdb0e69a85214c74a043b7a9b76058a98c8c258

Summary:        A container sandbox runtime focused on security, efficiency, and ease of use
Name:           gvisor
Version:        20230904.0
Release:        1%{?dist}
License:        ASL 2.0
URL:            https://github.com/google/gvisor
Source0:        %{url}/archive/%{commit}/%{name}-release-%{version}.tar.gz
# execute 'go mod vendor' under the source code path can generator vendor package
Source1:        %{name}-release-%{version}-vendor.tar.gz
BuildRequires:  golang >= 1.19 go-rpm-macros

%description
gVisor is an open-source, OCI-compatible sandbox runtime that provides
a virtualized container environment. It runs containers with a new
user-space kernel, delivering a low overhead container security
solution for high-density applications.

gVisor integrates with Docker, containerd and Kubernetes, making it
easier to improve the security isolation of your containers while
still using familiar tooling. Additionally, gVisor supports a variety
of underlying mechanisms for intercepting application calls, allowing
it to run in diverse host environments, including cloud-hosted virtual
machines.

%prep
%autosetup -p1 -a1 -n %{name}-%{commit}

%build
export GOPATH=$PWD/.gopath
mkdir -p ${GOPATH}/src/gvisor.dev
ln -sfn $PWD $GOPATH/src/%{goipath}
export CGO_ENABLED=0
export GOFLAGS="-mod=vendor"
%gobuild -o bin/runsc %{goipath}/runsc

%install
install -Dpm 0755  bin/runsc %{buildroot}%{_bindir}/runsc

%files
%license LICENSE
%doc README.md AUTHORS
%{_bindir}/runsc

%changelog
* Thu Sep 14 2023 jackeyji <jackeyji@tencent.com> - 20230904.0-1
- initial build
